<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>org.wfc</groupId>
    <artifactId>wfc</artifactId>
    <version>1.0.4</version>

    <name>wfc</name>
    <description>WANFi Control and Billing Management System</description>

    <properties>
        <wfc.version>1.0.4</wfc.version>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
        <java.version>1.8</java.version>
        <spring-boot.version>2.7.18</spring-boot.version>
        <spring-cloud.version>2021.0.9</spring-cloud.version>
        <spring-cloud-alibaba.version>2021.0.6.1</spring-cloud-alibaba.version>
        <spring-boot-admin.version>2.7.16</spring-boot-admin.version>
        <mybatis-plus.version>3.5.9</mybatis-plus.version>
        <tobato.version>1.27.2</tobato.version>
        <kaptcha.version>2.3.3</kaptcha.version>
        <pagehelper.boot.version>2.0.0</pagehelper.boot.version>
        <druid.version>1.2.23</druid.version>
        <dynamic-ds.version>4.3.1</dynamic-ds.version>
        <commons.io.version>2.13.0</commons.io.version>
        <velocity.version>2.3</velocity.version>
        <fastjson.version>2.0.53</fastjson.version>
        <jjwt.version>0.9.1</jjwt.version>
        <minio.version>8.2.2</minio.version>
        <poi.version>4.1.2</poi.version>
        <springdoc.version>1.6.9</springdoc.version>
        <transmittable-thread-local.version>2.14.4</transmittable-thread-local.version>
        <hutool.version>5.8.33</hutool.version>
        <lombok.version>1.18.36</lombok.version>
        <swagger.core.version>1.6.2</swagger.core.version>
        <org.mapstruct.version>1.6.3</org.mapstruct.version>
        <mail.version>1.6.2</mail.version>
        <ijapy.version>2.9.11</ijapy.version>
        <maven-compiler-plugin.version>3.8.1</maven-compiler-plugin.version>
        <wfc.nacos.server>${env.NACOS_SERVER_NAME}</wfc.nacos.server>
        <wfc.nacos.port>${env.NACOS_SERVER_PORT}</wfc.nacos.port>

        <!-- override dependency version -->
        <tomcat.version>9.0.96</tomcat.version>
        <logback.version>1.2.13</logback.version>
        <spring-framework.version>5.3.39</spring-framework.version>
    </properties>

    <!-- 依赖声明 -->
    <dependencyManagement>
        <dependencies>

            <!-- 覆盖SpringFramework的依赖配置-->
            <dependency>
                <groupId>org.springframework</groupId>
                <artifactId>spring-framework-bom</artifactId>
                <version>${spring-framework.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>

            <!-- SpringCloud 微服务 -->
            <dependency>
                <groupId>org.springframework.cloud</groupId>
                <artifactId>spring-cloud-dependencies</artifactId>
                <version>${spring-cloud.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>

            <!-- SpringCloud Alibaba 微服务 -->
            <dependency>
                <groupId>com.alibaba.cloud</groupId>
                <artifactId>spring-cloud-alibaba-dependencies</artifactId>
                <version>${spring-cloud-alibaba.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>

            <!-- SpringBoot 依赖配置 -->
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-dependencies</artifactId>
                <version>${spring-boot.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>

            <!-- Mybatis-Plus 配置 -->
            <dependency>
                <groupId>com.baomidou</groupId>
                <artifactId>mybatis-plus-boot-starter</artifactId>
                <version>${mybatis-plus.version}</version>
            </dependency>
            <dependency>
                <groupId>com.baomidou</groupId>
                <artifactId>mybatis-plus-generator</artifactId>
                <version>${mybatis-plus.version}</version>
            </dependency>

            <!-- 覆盖logback的依赖配置-->
            <dependency>
                <groupId>ch.qos.logback</groupId>
                <artifactId>logback-core</artifactId>
                <version>${logback.version}</version>
            </dependency>

            <dependency>
                <groupId>ch.qos.logback</groupId>
                <artifactId>logback-classic</artifactId>
                <version>${logback.version}</version>
            </dependency>

            <!-- 覆盖tomcat的依赖配置-->
            <dependency>
                <groupId>org.apache.tomcat.embed</groupId>
                <artifactId>tomcat-embed-core</artifactId>
                <version>${tomcat.version}</version>
            </dependency>

            <dependency>
                <groupId>org.apache.tomcat.embed</groupId>
                <artifactId>tomcat-embed-el</artifactId>
                <version>${tomcat.version}</version>
            </dependency>

            <dependency>
                <groupId>org.apache.tomcat.embed</groupId>
                <artifactId>tomcat-embed-websocket</artifactId>
                <version>${tomcat.version}</version>
            </dependency>

            <!-- FastDFS 分布式文件系统 -->
            <dependency>
                <groupId>com.github.tobato</groupId>
                <artifactId>fastdfs-client</artifactId>
                <version>${tobato.version}</version>
            </dependency>

            <!-- Springdoc webmvc 依赖配置 -->
            <dependency>
                <groupId>org.springdoc</groupId>
                <artifactId>springdoc-openapi-ui</artifactId>
                <version>${springdoc.version}</version>
            </dependency>

            <!-- 验证码 -->
            <dependency>
                <groupId>pro.fessional</groupId>
                <artifactId>kaptcha</artifactId>
                <version>${kaptcha.version}</version>
            </dependency>

            <!-- pagehelper 分页插件 -->
            <dependency>
                <groupId>com.github.pagehelper</groupId>
                <artifactId>pagehelper-spring-boot-starter</artifactId>
                <version>${pagehelper.boot.version}</version>
            </dependency>

            <!-- io常用工具类 -->
            <dependency>
                <groupId>commons-io</groupId>
                <artifactId>commons-io</artifactId>
                <version>${commons.io.version}</version>
            </dependency>

            <!-- excel工具 -->
            <dependency>
                <groupId>org.apache.poi</groupId>
                <artifactId>poi-ooxml</artifactId>
                <version>${poi.version}</version>
            </dependency>

            <!-- 代码生成使用模板 -->
            <dependency>
                <groupId>org.apache.velocity</groupId>
                <artifactId>velocity-engine-core</artifactId>
                <version>${velocity.version}</version>
            </dependency>

            <!-- JSON 解析器和生成器 -->
            <dependency>
                <groupId>com.alibaba.fastjson2</groupId>
                <artifactId>fastjson2</artifactId>
                <version>${fastjson.version}</version>
            </dependency>

            <!-- JWT -->
            <dependency>
                <groupId>io.jsonwebtoken</groupId>
                <artifactId>jjwt</artifactId>
                <version>${jjwt.version}</version>
            </dependency>

            <!-- 线程传递值 -->
            <dependency>
                <groupId>com.alibaba</groupId>
                <artifactId>transmittable-thread-local</artifactId>
                <version>${transmittable-thread-local.version}</version>
            </dependency>

            <!-- hutool工具 -->
            <dependency>
                <groupId>cn.hutool</groupId>
                <artifactId>hutool-all</artifactId>
                <version>${hutool.version}</version>
            </dependency>

            <!-- lombok工具 -->
            <dependency>
                <groupId>org.projectlombok</groupId>
                <artifactId>lombok</artifactId>
                <version>${lombok.version}</version>
            </dependency>

            <!-- 核心模块 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-core</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 接口模块 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-swagger</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 安全模块 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-security</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 数据脱敏 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-sensitive</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 权限范围 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-datascope</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 多数据源 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-datasource</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 分布式事务 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-seata</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- Swagger 依赖配置 -->
            <dependency>
                <groupId>io.swagger</groupId>
                <artifactId>swagger-annotations</artifactId>
                <version>${swagger.core.version}</version>
            </dependency>

            <!-- 日志记录 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-log</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 缓存服务 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-redis</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- mybatis服务 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-mybatis</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- MapStruct -->
            <dependency>
                <groupId>org.mapstruct</groupId>
                <artifactId>mapstruct</artifactId>
                <version>${org.mapstruct.version}</version>
            </dependency>

            <!-- 系统接口 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-api-system</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- omada接口 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-api-omada</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 用户平台接口 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-api-user</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 邮箱模块 -->
            <dependency>
                <groupId>org.wfc</groupId>
                <artifactId>wfc-common-mail</artifactId>
                <version>${wfc.version}</version>
            </dependency>

            <!-- 邮箱 -->
            <dependency>
                <groupId>com.sun.mail</groupId>
                <artifactId>javax.mail</artifactId>
                <version>${mail.version}</version>
            </dependency>

            <!-- 支付 -->
            <dependency>
                <groupId>com.github.javen205</groupId>
                <artifactId>IJPay-All</artifactId>
                <version>${ijapy.version}</version>
            </dependency>
        </dependencies>
    </dependencyManagement>

    <modules>
        <module>wfc-auth</module>
        <module>wfc-gateway</module>
        <module>wfc-visual</module>
        <module>wfc-modules</module>
        <module>wfc-api</module>
        <module>wfc-common</module>
    </modules>
    <packaging>pom</packaging>

    <dependencies>
        <!-- bootstrap 启动器 -->
        <dependency>
            <groupId>org.springframework.cloud</groupId>
            <artifactId>spring-cloud-starter-bootstrap</artifactId>
        </dependency>
    </dependencies>

    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>${maven-compiler-plugin.version}</version>
                <configuration>
                    <source>${java.version}</source>
                    <target>${java.version}</target>
                    <encoding>${project.build.sourceEncoding}</encoding>
                    <annotationProcessorPaths>
                        <path>
                            <groupId>org.projectlombok</groupId>
                            <artifactId>lombok</artifactId>
                            <version>${lombok.version}</version>
                        </path>
                        <path>
                            <groupId>org.mapstruct</groupId>
                            <artifactId>mapstruct-processor</artifactId>
                            <version>${org.mapstruct.version}</version>
                        </path>
                    </annotationProcessorPaths>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jar-plugin</artifactId>
                <version>3.2.0</version>
                <configuration>
                    <archive>
                        <manifestEntries>
                            <Implementation-Version>${wfc.version}</Implementation-Version>
                        </manifestEntries>
                    </archive>
                </configuration>
            </plugin>            
        </plugins>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-maven-plugin</artifactId>
                    <version>${spring-boot.version}</version>
                    <executions>
                        <execution>
                            <goals>
                                <goal>repackage</goal>
                            </goals>
                        </execution>
                    </executions>
                </plugin>
            </plugins>
        </pluginManagement>
        <resources>
            <resource>
                <directory>src/main/resources</directory>
                <filtering>true</filtering>
            </resource>
        </resources>
    </build>

    <repositories>
        <repository>
            <id>public</id>
            <name>aliyun nexus</name>
            <url>https://maven.aliyun.com/repository/public</url>
            <releases>
                <enabled>true</enabled>
            </releases>
        </repository>
    </repositories>

    <pluginRepositories>
        <pluginRepository>
            <id>public</id>
            <name>aliyun nexus</name>
            <url>https://maven.aliyun.com/repository/public</url>
            <releases>
                <enabled>true</enabled>
            </releases>
            <snapshots>
                <enabled>false</enabled>
            </snapshots>
        </pluginRepository>
    </pluginRepositories>

    <!-- 环境 -->
    <profiles>
        <!-- 开发 -->
        <profile>
            <id>dev</id>
            <activation>
                <!--默认激活配置-->
                <activeByDefault>true</activeByDefault>
            </activation>
            <properties>
                <!--当前环境-->
                <profileName>dev</profileName>
                <nacosServerAddr>192.168.2.248:8848</nacosServerAddr>
                <nacosNamespace>wfc-dev</nacosNamespace>
            </properties>
        </profile>
        <!-- 测试 -->
        <profile>
            <id>test</id>
            <properties>
                <!--当前环境-->
                <profileName>test</profileName>
                <nacosServerAddr>192.168.2.248:8848</nacosServerAddr>
                <nacosNamespace>wfc-test</nacosNamespace>
            </properties>
        </profile>
        <!-- 生产 -->
        <profile>
            <id>prod</id>
            <properties>
                <!--当前环境-->
                <profileName>prod</profileName>
                <nacosServerAddr>${wfc.nacos.server}:${wfc.nacos.port}</nacosServerAddr>
                <nacosNamespace>wfc-prod</nacosNamespace>
            </properties>
        </profile>
        <!-- cyc -->
        <profile>
            <id>cyc</id>
            <properties>
                <!--当前环境-->
                <profileName>cyc</profileName>
                <nacosServerAddr>192.168.9.50:8848</nacosServerAddr>
                <nacosNamespace>wfc-cyc</nacosNamespace>
            </properties>
        </profile>
    </profiles>
</project>